"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_1 = require("./base");
var cookies = (function () {
    if (!base_1.isStandardBrowserEnv()) {
        return {
            write: function () {
            },
            read: function (_name) { return null; },
            remove: function () {
            }
        };
    }
    var cookies = {
        write: function (name, value, expires, path, domain, secure) {
            var cookie = [];
            cookie.push(name + '=' + encodeURIComponent(value));
            if (base_1.isNumber(expires)) {
                cookie.push('expires=' + new Date(expires).toUTCString());
            }
            if (base_1.isString(path)) {
                cookie.push('path=' + path);
            }
            if (base_1.isString(domain)) {
                cookie.push('domain=' + domain);
            }
            if (secure === true) {
                cookie.push('secure');
            }
            document.cookie = cookie.join('; ');
        },
        read: function (name) {
            var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
            return match ? decodeURIComponent(match[3]) : null;
        }
    };
    return tslib_1.__assign({}, cookies, { remove: function (name) { return cookies.write(name, '', Date.now() - 86400000); } });
})();
exports.cookies = cookies;
//# sourceMappingURL=cookies.js.map