"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
var enhanceError = function (error, config, code, request, response) {
    error.config = config;
    if (code) {
        error.code = code;
    }
    error.request = request;
    error.response = response;
    error.toJSON = function () {
        return base_1.pick(error, [
            'message',
            'name',
            'description',
            'number',
            'fileName',
            'lineNumber',
            'columnNumber',
            'stack',
            'config',
            'code'
        ]);
    };
    return error;
};
exports.enhanceError = enhanceError;
var createError = function (message, config, code, request, response) { return enhanceError(new Error(message), config, code, request, response); };
exports.createError = createError;
//# sourceMappingURL=createError.js.map