"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var createError_1 = require("./createError");
var getObserverHandler = function (observer) {
    var handled = false;
    return {
        emitError: function (err) {
            if (handled) {
                return;
            }
            handled = true;
            observer.error(err);
        },
        emitComplete: function (response) {
            if (handled) {
                return;
            }
            handled = true;
            var validateStatus = response.config.validateStatus;
            if (!validateStatus || validateStatus(response.status)) {
                observer.next(tslib_1.__assign({}, response, { type: "Response" }));
                observer.complete();
            }
            else {
                observer.error(createError_1.createError("Request failed with status code " + response.status, response.config, null, response.request, response));
            }
        }
    };
};
exports.getObserverHandler = getObserverHandler;
//# sourceMappingURL=getObserverHandler.js.map