"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
var log_1 = require("./log");
var log = log_1.getLogger('parseJsonResponse');
var parseJsonResponse = function (status, body) {
    var ok = status >= 200 && status < 300;
    log.info("Status '" + status + "' considered as '" + (ok ? 'ok' : 'not ok') + "'");
    var originalBody = body;
    var ret = body.replace(base_1.XSSI_PREFIX, '');
    try {
        ret = ret !== '' ? JSON.parse(ret) : null;
        return { ok: ok, body: ret };
    }
    catch (error) {
        ret = originalBody;
        if (ok) {
            ret = { error: error, text: ret };
        }
        log.error("parse response body failed, returning original body with error", error);
        return { ok: false, body: ret };
    }
};
exports.parseJsonResponse = parseJsonResponse;
//# sourceMappingURL=parseJsonResponse.js.map