import * as tslib_1 from "tslib";
import { of, throwError } from 'rxjs';
import { catchError, map, mergeMap } from 'rxjs/operators';
import { isString } from '../utils/base';
import { buildURL } from '../utils/urls';
import { dispatchRequest } from './dispatchRequest';
var buildConfig = function (urlOrConfig, config) {
    var baseConfig = (isString(urlOrConfig) ? config : urlOrConfig) || {};
    if (isString(urlOrConfig)) {
        baseConfig.url = urlOrConfig;
    }
    return tslib_1.__assign({}, baseConfig, { url: isString(urlOrConfig) ? urlOrConfig : baseConfig.url, method: baseConfig.method ? baseConfig.method.toLowerCase() : "get" });
};
var Oxid = (function () {
    function Oxid(baseConfig) {
        var _this = this;
        this.baseConfig = baseConfig;
        this.interceptors = {
            request: [],
            response: []
        };
        ["delete", "get", "head", "options"].forEach(function (method) { return (_this[method] = function (url, config) { return _this.request(tslib_1.__assign({}, config, { method: method, url: url })); }); });
        ["post", "put", "patch"].forEach(function (method) {
            return (_this[method] = function (url, data, config) {
                return _this.request(tslib_1.__assign({}, config, { data: data, method: method, url: url }));
            });
        });
    }
    Oxid.prototype.request = function (urlOrConfig, config) {
        var _a;
        var mergedConfig = tslib_1.__assign({}, this.baseConfig, buildConfig(urlOrConfig, config));
        var _b = this.interceptors, request = _b.request, response = _b.response;
        var buildInterceptorOperators = function (interceptors) {
            return interceptors.reduce(function (acc, _a) {
                var next = _a.next, error = _a.error;
                acc.push(map(next));
                acc.push(catchError(function (err) { return throwError(error(err)); }));
                return acc;
            }, []);
        };
        return (_a = of(mergedConfig)).pipe.apply(_a, buildInterceptorOperators(request).concat([mergeMap(function (value) { return dispatchRequest(value); })], buildInterceptorOperators(response)));
    };
    Oxid.prototype.getUri = function (config) {
        var _a = tslib_1.__assign({}, this.baseConfig, buildConfig(config)), url = _a.url, params = _a.params, paramsSerializer = _a.paramsSerializer;
        if (!url) {
            throw new Error("Invalid request configuration");
        }
        return buildURL(url, params, paramsSerializer).replace(/^\?/, '');
    };
    return Oxid;
}());
export { Oxid };
//# sourceMappingURL=oxid.js.map