import * as tslib_1 from "tslib";
import { isNumber, isStandardBrowserEnv, isString } from './base';
var cookies = (function () {
    if (!isStandardBrowserEnv()) {
        return {
            write: function () {
            },
            read: function (_name) { return null; },
            remove: function () {
            }
        };
    }
    var cookies = {
        write: function (name, value, expires, path, domain, secure) {
            var cookie = [];
            cookie.push(name + '=' + encodeURIComponent(value));
            if (isNumber(expires)) {
                cookie.push('expires=' + new Date(expires).toUTCString());
            }
            if (isString(path)) {
                cookie.push('path=' + path);
            }
            if (isString(domain)) {
                cookie.push('domain=' + domain);
            }
            if (secure === true) {
                cookie.push('secure');
            }
            document.cookie = cookie.join('; ');
        },
        read: function (name) {
            var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
            return match ? decodeURIComponent(match[3]) : null;
        }
    };
    return tslib_1.__assign({}, cookies, { remove: function (name) { return cookies.write(name, '', Date.now() - 86400000); } });
})();
export { cookies };
//# sourceMappingURL=cookies.js.map