import { pick } from './base';
var enhanceError = function (error, config, code, request, response) {
    error.config = config;
    if (code) {
        error.code = code;
    }
    error.request = request;
    error.response = response;
    error.toJSON = function () {
        return pick(error, [
            'message',
            'name',
            'description',
            'number',
            'fileName',
            'lineNumber',
            'columnNumber',
            'stack',
            'config',
            'code'
        ]);
    };
    return error;
};
var createError = function (message, config, code, request, response) { return enhanceError(new Error(message), config, code, request, response); };
export { createError, enhanceError };
//# sourceMappingURL=createError.js.map