import * as tslib_1 from "tslib";
import { createError } from './createError';
var getObserverHandler = function (observer) {
    var handled = false;
    return {
        emitError: function (err) {
            if (handled) {
                return;
            }
            handled = true;
            observer.error(err);
        },
        emitComplete: function (response) {
            if (handled) {
                return;
            }
            handled = true;
            var validateStatus = response.config.validateStatus;
            if (!validateStatus || validateStatus(response.status)) {
                observer.next(tslib_1.__assign({}, response, { type: "Response" }));
                observer.complete();
            }
            else {
                observer.error(createError("Request failed with status code " + response.status, response.config, null, response.request, response));
            }
        }
    };
};
export { getObserverHandler };
//# sourceMappingURL=getObserverHandler.js.map