import { isFunction } from './base';
var noopLog = function () {
};
var log = {
    debug: noopLog,
    info: noopLog,
    warn: noopLog,
    error: noopLog
};
var getLogger = function (identifier) {
    return Object.keys(log).reduce(function (acc, key) {
        acc[key] = function (message) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            log[key].apply(log, ["oxid:" + identifier + "::" + message].concat(args));
        };
        return acc;
    }, {});
};
function enableLogger(logger) {
    var isLogFunction = isFunction(logger);
    var baseLogger = Object.keys(logger)
        .map(function (key) { return [key, logger[key]]; })
        .filter(function (value) { return !!value[1]; })[0];
    if (!baseLogger) {
        throw new Error('at least one logger function need to be supplied');
    }
    Object.keys(log).forEach(function (key) { return (log[key] = isLogFunction ? logger : logger[key] || baseLogger); });
}
export { enableLogger, getLogger };
//# sourceMappingURL=log.js.map