var ignoreDuplicateOf = Object.freeze([
    'age',
    'authorization',
    'content-length',
    'content-type',
    'etag',
    'expires',
    'from',
    'host',
    'if-modified-since',
    'if-unmodified-since',
    'last-modified',
    'location',
    'max-forwards',
    'proxy-authorization',
    'referer',
    'retry-after',
    'user-agent'
]);
var parseHeaders = function (headers) {
    if (!headers) {
        return {};
    }
    return headers
        .split('\n')
        .map(function (line) { return line.split(/:(.+)/, 2).map(function (x) { return x.trim(); }); })
        .reduce(function (acc, _a) {
        var originalKey = _a[0], value = _a[1];
        if (!originalKey) {
            return acc;
        }
        var key = originalKey.toLowerCase();
        if (acc[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
            return acc;
        }
        if (key === 'set-cookie') {
            acc[key] = (acc[key] ? acc[key] : []).concat([value]);
        }
        else {
            acc[key] = acc[key] ? acc[key] + ", " + value : value;
        }
        return acc;
    }, {});
};
export { parseHeaders };
//# sourceMappingURL=parseHeaders.js.map