import { RequestConfig, Transformer } from '../Request';
import { Observable } from 'rxjs';
import { HttpEvent } from '../Response';
/**
 * @internal
 * Transform the data for a request or a response
 *
 * @param {Object|String} data The data to be transformed
 * @param {Array} headers The headers for the request or response
 * @param {Array|Function} transformFunctions A single function or Array of functions
 * @returns {*} The resulting transformed data
 */
declare const transformData: (data: string | object, headers: Record<string, any>[], transformFunction?: Transformer | Transformer[] | undefined) => object;
/**
 * Dispatch a request to the server using the configured adapter.
 *
 * @param {RequestConfig} config The config that is to be used for the request
 */
declare const dispatchRequest: <T extends string | object = any>(config: RequestConfig) => Observable<HttpEvent<T>>;
export { transformData, dispatchRequest };
//# sourceMappingURL=dispatchRequest.d.ts.map