import { Observable } from 'rxjs';
import { RequestConfig } from '../Request';
import { HttpErrorResponse, HttpEvent } from '../Response';
declare type requestMethodType = <T>(url: string, config?: RequestConfig) => Observable<HttpEvent<T>>;
declare type requestMethodWithDataType = <T, U>(url: string, data?: T, config?: RequestConfig) => Observable<HttpEvent<U>>;
declare class Oxid {
    private readonly baseConfig;
    readonly delete: requestMethodType;
    readonly get: requestMethodType;
    readonly head: requestMethodType;
    readonly options: requestMethodType;
    readonly post: requestMethodWithDataType;
    readonly put: requestMethodWithDataType;
    readonly patch: requestMethodWithDataType;
    readonly interceptors: {
        request: Array<{
            next: (config: RequestConfig) => RequestConfig;
            error: (err: HttpErrorResponse) => any;
        }>;
        response: Array<{
            next: <T = any, U = T>(response: HttpEvent<T>) => HttpEvent<U>;
            error: (err: HttpErrorResponse) => any;
        }>;
    };
    constructor(baseConfig: RequestConfig);
    request<T extends object | string = any>(url: string, config?: RequestConfig): Observable<HttpEvent<T>>;
    request<T extends object | string = any>(url: string): Observable<HttpEvent<T>>;
    request<T extends object | string = any>(config: RequestConfig): Observable<HttpEvent<T>>;
    getUri(config: RequestConfig): string;
}
export { Oxid, requestMethodType, requestMethodWithDataType };
//# sourceMappingURL=oxid.d.ts.map