declare type logFunctionType = (message: string, ...optionalParams: Array<any>) => void;
interface Logger {
    debug: logFunctionType;
    info: logFunctionType;
    warn: logFunctionType;
    error: logFunctionType;
}
/**
 * Returns augumented logger object with namespace.
 *
 * @internal
 */
declare const getLogger: (identifier: string) => Logger;
/**
 * Set logger for prints out internal behavior.
 * @param {logFunctionType | Logger} logger Logger object contains loglevel function (debug, info, warn, error)
 * or single function to log. If single function is provided, all loglevel will use given function.
 * If logger object is provided, it should have all loglevel function.
 */
declare function enableLogger(logger: logFunctionType): void;
declare function enableLogger(logger: Partial<Logger>): void;
export { logFunctionType, Logger, enableLogger, getLogger };
//# sourceMappingURL=log.d.ts.map