/**
 * Parse headers into an object
 *
 * ```
 * Date: Wed, 27 Aug 2014 08:58:49 GMT
 * Content-Type: application/json
 * Connection: keep-alive
 * Transfer-Encoding: chunked
 * ```
 *
 * @param {String} headers Headers needing to be parsed
 * @returns {Record<string, string>} Headers parsed into an object
 */
declare const parseHeaders: (headers: string) => Record<string, string>;
export { parseHeaders };
//# sourceMappingURL=parseHeaders.d.ts.map